﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using CharnyPluginSystem;

namespace CPSExampleCSharp
{
    public partial class Form1 : Form
    {
        private List<Plugin> pluginList = new List<Plugin>();

        public Form1()
        {
            InitializeComponent();
        }

        public void SetText(string text)
        {
            this.Text = text;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            LoadPlugins();
        }

        private void LoadPlugins()
        {
            pluginList = PluginManager.SearchPlugins(Application.StartupPath);

            foreach (Plugin plugin in pluginList)
            {
                plugin.Activate(this);
                AddPlugin(plugin);
            }
        }

        private void AddPlugin(Plugin plugin)
        {
            ListViewItem item;

            string[] data = new string[4];
            data[0] = plugin.GetName();
            data[1] = plugin.GetDescription();
            data[2] = plugin.GetAuthor();
            data[3] = plugin.GetCreationDate().ToString();

            item = new ListViewItem(data);
            listView.Items.Add(item);

            labelPlugins.Text = pluginList.Count.ToString();
        }

        private void butLoad_ButtonClick(object sender, EventArgs e)
        {
            LoadPlugin();
        }

        private void LoadPlugin()
        {
            OpenFileDialog ofd = new OpenFileDialog();
            ofd.Filter = "Dynamic link library (*.dll)|*.dll";
            ofd.Title = "Choose a plugin";

            if (ofd.ShowDialog() == DialogResult.OK)
            {
                if (PluginManager.ValidatePlugin(ofd.FileName))
                {
                    Plugin plugin = PluginManager.LoadPlugin(ofd.FileName);
                    plugin.Activate(this);
                    pluginList.Add(plugin);
                    AddPlugin(plugin);
                }
                else
                {
                    MessageBox.Show("Invalid plugin!", "Invalid!", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
        }
    }
}
