﻿Imports CharnyPluginSystem

Public Class Form1

    Private pluginList As New List(Of Plugin)()

    Public Sub SetText(ByVal text As String)
        Me.Text = text
    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
        LoadPlugins()
    End Sub

    Private Sub LoadPlugins()
        pluginList = PluginManager.SearchPlugins(Application.StartupPath)

        For Each plugin As CharnyPluginSystem.Plugin In pluginList
            plugin.Activate(Me)
            AddPlugin(plugin)
        Next
    End Sub

    Private Sub AddPlugin(ByVal plugin As Plugin)
        Dim item As ListViewItem

        Dim data As String() = New String(3) {}
        data(0) = plugin.GetName()
        data(1) = plugin.GetDescription()
        data(2) = plugin.GetAuthor()
        data(3) = plugin.GetCreationDate().ToString()

        item = New ListViewItem(data)
        ListView.Items.Add(item)

        labelPlugins.Text = pluginList.Count.ToString()
    End Sub

    Private Sub butLoad_ButtonClick(ByVal sender As Object, ByVal e As EventArgs) Handles butLoad.ButtonClick
        LoadPlugin()
    End Sub

    Private Sub LoadPlugin()
        Dim ofd As New OpenFileDialog()
        ofd.Filter = "Dynamic link library (*.dll)|*.dll"
        ofd.Title = "Choose a plugin"

        If ofd.ShowDialog() = DialogResult.OK Then
            If PluginManager.ValidatePlugin(ofd.FileName) Then
                Dim plugin As Plugin = PluginManager.LoadPlugin(ofd.FileName)
                plugin.Activate(Me)
                pluginList.Add(plugin)
                AddPlugin(plugin)
            Else
                MessageBox.Show("Invalid plugin!", "Invalid!", MessageBoxButtons.OK, MessageBoxIcon.[Error])
            End If
        End If
    End Sub


End Class
